
"sdpac2" <- function(data,dis,pop,rho,F,nperm=10) {

  pop <- as.numeric(factor(pop))
#  npops <- max(pop);
  res <- .C("sdpac"
            ,as.integer(t(data))
            ,as.integer(nrow(data))
            ,as.integer(ncol(data))
            ,as.double(dis)
            ,as.integer(pop-1)
            ,as.double(rho)
            ,as.integer(length(rho))
            ,as.double(F)
            ,as.integer(length(F))
            ,as.integer(nperm)
            ,as.double(numeric(length(rho)*length(F)))
            )[[11]]
  list(ll=matrix(res,ncol=length(rho),byrow=TRUE),F=F,rho=rho);
 #  void sdpac(int *data, int *ss, int *sites, double *dis, int *pop, int *npops, double *rho, int *nrho
#	     ,double *F, int *nF, int *nperm,double *ll)

}


"sdpac" <- function(data,dis,pop,rho,Fst,driveF,driverho,nperm=10)
{
  pop <- as.numeric(factor(pop)) # pop as an integer from 1 to npops
  drvals <- numeric(2)           # driver values
  if (missing(driveF)) drvals[1] <- median(F)
  else drvals[1] <- driveF
  if (missing(driverho)) drvals[2] <- median(rho)
  else drvals[2] <- driverho
  if (!is.matrix(data))
    stop("need a matrix of data")
  if (length(dis)!=(ncol(data)-1))
    stop("length of distances must be number of columns of data -1")
  
  res <- .C("sdpacb"
            ,as.integer(t(data))
            ,as.integer(nrow(data))
            ,as.integer(ncol(data))
            ,as.double(dis)
            ,as.integer(pop-1)
            ,as.double(rho)
            ,as.integer(length(rho))
            ,as.double(Fst)
            ,as.integer(length(Fst))
            ,as.double(drvals)
            ,as.integer(nperm)
            ,as.double(numeric(length(rho)*length(Fst)))
            )[[12]]
  list(ll=matrix(res,ncol=length(rho),byrow=TRUE),Fst=Fst,rho=rho);
}

"sdpacpath" <- function(data,dis,pop,rho,F,driveF,driverho,nperm=10) {

  pop <- as.numeric(factor(pop))
  drvals <- numeric(2)
  if (missing(driveF)) drvals[1] <- median(F)
  else drvals[1] <- driveF
  if (missing(driverho)) drvals[2] <- median(rho)
  else drvals[2] <- driverho
  if (!is.matrix(data))
    stop("need a matrix of data")
  if (length(dis)!=(ncol(data)-1))
    stop("length of distances must be number of columns of data -1")
  
  res <- .C("sdpacpath"
            ,as.integer(t(data))
            ,as.integer(nrow(data))
            ,as.integer(ncol(data))
            ,as.double(dis)
            ,as.integer(pop-1)
            ,as.double(rho)
            ,as.integer(length(rho))
            ,as.double(F)
            ,as.integer(length(F))
            ,as.double(drvals)
            ,as.integer(nperm)
            ,as.double(numeric(length(rho)*length(F)))
            )[[12]]
  list(ll=matrix(res,ncol=length(rho),byrow=T),F=F,rho=rho);

}
