\name{mlpac}
\alias{mlpac}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Calculate the maximum likelihood estimate of rho (unscaled)}
\description{
  A function to calculate the maximum likelihood estimate of rho
  (unscaled) by the method of Li & Stephens (Genetics 2003).
}
\usage{
mlpac(data, dis, interval = c(0, 10), nperm = 10, seed = 0)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{data}{ A matrix of veriation data (0's and 1's). }
  \item{dis}{ The distance between sites. }
  \item{interval}{ The starting interval for the maximisation.}
  \item{nperm}{ The number of permutations}
  \item{seed}{ A seed for the radnom number generator:  If seed=0 then
    the current random number seen is used}
}
\value{
  returns the outoput from an optimise function.  
     A list with components 'minimum' (or 'maximum') and 'objective'
     which give the location of the minimum (or maximum) and the value
     of the function at that point.
   }
\references{ \url{http://www.mas.ncl.ac.uk/~nijw} }
\author{ Ian Wilson <I.J.Wilson@ncl.ac.uk}

\seealso{\code{\link{pac}}, \code{\link{optimise}}}
\examples{
data(sim1) ## sim1 is provided by the genomic package
mlpac(sim1$d,diff(sim1$pos))
}
\keyword{optimize }

