\name{pac}
\alias{pac}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Calculate the PAC likelihood for genomic data}
\description{
  Calculate the Li \& Stephens Product of Approximate Conditionals
  for a matrix of genomic 0,1 SNP data.  This is the uncorrected
  PAC from the Li \& Stephens genetics paper.
}
\usage{
pac(data,distances,rho,nperm=10)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  
  \item{data}{A matrix (haplotypes by row) of biallic SNP data (0s and
    1s)}
  \item{distances}{The distances between the SNPs}
  \item{rho}{Values of the population recombination rate rho to
    calculate}
  \item{nperm}{The number of permutations}
  
}
\value{
  A vector of log likelihoods at the values of rho given.
}
  \references{Li \& Stephens. 2003. Modeling Linkage Disequilibrium and
  Identifying Recombination Hotspots Using Single-Nucleotide
  Polymorphism Data. Genetics 165, 2213-2233.
  }
  
\author{ Ian J. Wilson <I.J.Wilson@ncl.ac.uk>}

\seealso{\code{\link{mlpac}} }
\examples{
library(ARG)
## get data for 10 individuals at 20 sites with rho = 0.1
set.seed(101)
a <- mutate(simARG(10,300,0.1),20)
rho <- seq(0,0.6,by=0.01)
plot(rho,pac(a$d,diff(a$pos),rho=rho),type="l",xlab=expression(rho)
,ylab="Log Likelihood")
}
\keyword{ distribution }% at least one, from doc/KEYWORDS
\keyword{ htest }% __ONLY ONE__ keyword per line
