\name{pac-package}
\alias{pac-package}
%\alias{pac}
\docType{package}
\title{
Calculate Product of Approximate Conditionals (PAC) likelihoods for
genomic data.
}
\description{
 A package to calculate Product of Approximate Conditionals (PAC) likelihoods for
genomic data based on the methods of Li & Stephens (2003), and my
extensions for subdivided populations.  This does not use the correction
factor in the original paper.
}
\details{
\tabular{ll}{
Package: \tab pac\cr
Type: \tab Package\cr
Version: \tab 1.0\cr
Date: \tab 2005-12-05\cr
License: \tab What license is it under?\cr
}
Use this package to perform calculations and draw samples under the
PAC model of Li & Stephens (2003), and under my extension (Wilson)
}
\author{
  Ian Wilson \email{I.J.Wilson@ncl.ac.uk}

}
\references{
  Li, N & Stephens M. 2003. Modeling linkage disequilibrium and
  identfying recombination hotspots using single-nucleotide polymorphism
  data. Genetics. 165, 2213-2233

  Wilson. Approximate Likelihood Methods for SNP data with Genetic Correlations 
}
\keyword{ package }
%\seealso{
%\code{\link[<pkg>:<pkg>-package]{<pkg>}} ~~
%}
\examples{
gg <- structure(c(0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 
0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 1, 0, 1, 0, 1, 0, 0, 
0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 
1, 1, 0, 1, 1, 1, 1, 1, 0, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 1
), .Dim = c(8, 10))

pos <- c(9, 12, 14, 26, 50, 59, 71, 76, 90, 91)
rho <- seq(0,0.5,0.01)

plot(rho,pac(gg,diff(pos),rho),type="l",ylab="Approximate PAC Likelihood")
path(gg,diff(pos))
filled.contour(1:10,1:8,t(sharedsection(gg,diff(pos),nperm=100)))
}
