#include "pact2.H"
#include <vector>
#include "tnt/tnt.h"
#include <iostream>
#include "Rhapdata.H"

// class hapdata {
// public: 
//   hapdata(int *data, int ss, int sites):
//     dat(data),n_(ss), sites_(sites) {}

//   int value(int ind, int site) const {
//     return *(dat +sites_*ind+site);
//   }
//   int sites() const {
//     return sites_;
//   }
//   int n() const {
//     return n_;
//   }
//    void print(std::ostream &o) {
//     for (int i=0;i<n_;i++) {
//       for (int j=0;j<sites_;j++) 
// 	o << value(i,j) << " ";
//       o << std::endl;
//     }
/// /   }
 
  
// private:
//   int *dat;
//   int n_;
//   int sites_; 
// };

class Rpac {
public:
  Rpac(int *data, int nsamp, int nsites, double *d)
    :hd(data,nsamp,nsites),
     dis(nsites-1,d),
     p(hd,dis) {
    //  hd.print(std::cout);
  }
  double ll(double rho,int nperm) {
    return p(rho,nperm);
  }
  double sample(double rho, int *path, int *order, double *ll) {
    TNT::Array2D<int> ph=p.sample(rho,order,*ll);
    for (int i=0;i<hd.n();i++)
      for (int j=0;j<hd.sites();j++)
	path[i*hd.sites()+j]=ph[i][j];
  }
  void ll(double *llike, double *rho,int nrho, int nperm) {
    p(llike,rho,nrho,nperm);
  }
 void recomb(double *recs, double rho, int nperm) {
   TNT::Array1D<double> rcs=p.recombinations(rho,true,nperm);
   for (int i=0;i<hd.sites()-1;i++) recs[i]=rcs[i];
 }
  void sharedanc(int pos,double rho, int nperm,double *res) {
    TNT::Array2D<double> sa = p.ScaledSharedAncestry(pos,rho,true,nperm);
    for (int i=0;i<hd.n();i++)
      for (int j=0;j<hd.sites();j++)
	res[i*hd.sites()+j]=sa[i][j];
  }
private:
  //TNT::Array2D<int> ordering;
  hapdata hd;
  TNT::Array1D<double> dis;
  pact<hapdata> p; 
};


extern "C" {
  void simplepac(int *data, int *ss, int *sites, double *d, double *rho, int *nrho,int *nperm,double *ll) {
    Rpac r(data,*ss,*sites,d);
    r.ll(ll,rho,*nrho,*nperm);
    return;
  }
 void simplepac1(int *data, int *ss, int *sites, double *d, double *rho
		 , int *nperm,double *ll) {
    Rpac r(data,*ss,*sites,d);
    *ll=r.ll(*rho,*nperm);
    return;
  }

 void recombinations(int *data, int *ss, int *sites, double *d, double *rho, 
		     int *nperm,double  *recs) {
    Rpac r(data,*ss,*sites,d);
    r.recomb(recs,*rho,*nperm);
  }

  void samplepath(int *data, int *ss, int *sites, double *d, double *rho, 
		  int  *path, int *order,double *ll) {
      Rpac r(data,*ss,*sites,d);
      r.sample(*rho,path,order,ll);
  }
  void sharedancestry(int *data, int *ss, int *sites, double *d, int *pos
		      , double *rho, int *nperm, double *res) {
    Rpac r(data,*ss,*sites,d);
    r.sharedanc(*pos,*rho,*nperm,res);
  }
						
}
