#include "spac2.H"
#include <vector>
#include <iostream>
#include <algorithm>  // for random_shuffle
#include "tnt/tnt.h"
#include "Rhapdata.H"



// class Rspac {
// public:
//   Rspac(int *data, int nsamp, int nsites, int *loc, double *d)
//     :hd(data,nsamp,nsites),
//      dis(nsites-1,d),
//      location(nsamp,loc),
//      p(hd,dis,loc) {
//   }

  
  



//  }
//   public:
//   TNT::Array2D<int> ordering;
//   hapdata hd;
//   TNT::Array1D<double> dis;
//   TNT::Array1D<int> location;
//   spact<hapdata> p; 
// };

extern "C" {
  void sdpac(int *data, int *ss, int *sites, double *dis, int *pop,
	     // int *npops, 
double *rho, int *nrho
	     ,double *F, int *nF, int *nperm,double *ll) {
    
    hapdata hd(data,*ss,*sites);
    TNT::Array1D<double> d(*sites-1,dis);
    TNT::Array1D<int> location(*ss,pop);

    //  std::cerr << d << location;
  
    
    TNT::Array3D<double> llike(*nF,*nrho,*nperm);
    TNT::Array1D<double> lsamp(*nperm);
    TNT::Array3D<double> weights(*nF,*nrho,*nperm,0.0);
    
    rng r;
    // initialise order
    TNT::Array1D<int> order(*ss);
    for (int i=0;i<*ss;i++) order[i]=i;
    
    // std::cerr << order;

    spact<hapdata> p(hd,d,location);  
    for (int i=0;i<*nperm;i++) {
      TNT::Array1D<double> driveF(p.npops(),r(F[0],F[*nF-1]));
      double driverrho=r(rho[0],rho[*nrho-1]);
      std::random_shuffle(&order[0],&order[0]+*ss,r);
      std::pair<double,double> lp=p.sample(driverrho,driveF,order,r);
      lsamp[i]=lp.second;
      // std::cerr << i << " " <<  lsamp[i] << std::endl;
      
      
      for (int j=0;j<*nF;j++) {
	TNT::Array1D<double> tmpF(p.npops(),F[j]);
	for (int k=0;k<*nrho;k++) {
	  std::pair<double,double> lpi=p.lpsample(rho[k],&tmpF[0],order);
	  double lprior=p.logprior(rho[k],&tmpF[0],order);
	  
	  weights[j][k][i] = exp(lprior-lsamp[i]);
	  llike[j][k][i]=lpi.first;
	}
      }
    }
    
    for (int j=0;j<*nF;j++) {
      for (int k=0;k<*nrho;k++) {
	double W=std::accumulate(&weights[j][k][0],&weights[j][k][0]+*nperm,0.0);
	TNT::Array1D<double> results(*nperm);
	for (int ii=0;ii<*nperm;ii++) results[ii]=log(weights[j][k][ii])+llike[j][k][ii];
	double scale=*(std::max_element(&results[0],&results[0]+*nperm));
	double sm=0.0;
	for (int i=0;i<*nperm;i++)  sm += exp(results[i]-scale);
	ll[j*(*nrho)+k]  = log(sm) - log(W) + scale;
      }
    } 
  }
  void sdpacb(int *data, int *ss, int *sites, double *dis, int *pop
	      , double *rho, int *nrho
	      ,double *F, int *nF, double *drive, int *nperm,double *ll) {
    
    hapdata hd(data,*ss,*sites);
    TNT::Array1D<double> d(*sites-1,dis);
    TNT::Array1D<int> location(*ss,pop);

    //  std::cerr << d << location;
    
    
    TNT::Array3D<double> llike(*nF,*nrho,*nperm);
    TNT::Array1D<double> lsamp(*nperm);
    TNT::Array3D<double> weights(*nF,*nrho,*nperm,0.0);
    
    rng r;
    // initialise order
    TNT::Array1D<int> order(*ss);
    for (int i=0;i<*ss;i++) order[i]=i;
    
    spact<hapdata> p(hd,d,location);  

    // std::cerr << order;
    TNT::Array1D<double> driveF(p.npops(),drive[0]);
    double driverrho=drive[1];    
        for (int i=0;i<*nperm;i++) {
      std::random_shuffle(&order[0],&order[0]+*ss,r);
      std::pair<double,double> lp=p.sample(driverrho,driveF,order,r);
      lsamp[i]=lp.second;
      // std::cerr << i << " " <<  lsamp[i] << std::endl;
      
      for (int j=0;j<*nF;j++) {
	TNT::Array1D<double> tmpF(p.npops(),F[j]);
	for (int k=0;k<*nrho;k++) {
	  std::pair<double,double> lpi=p.lpsample(rho[k],&tmpF[0],order);
	  double lprior=p.logprior(rho[k],&tmpF[0],order);
	  
	  weights[j][k][i] = exp(lprior-lsamp[i]);
	  llike[j][k][i]=lpi.first;
	}
      }
    }
    
    for (int j=0;j<*nF;j++) {
      for (int k=0;k<*nrho;k++) {
	double W=std::accumulate(&weights[j][k][0],&weights[j][k][0]+*nperm,0.0);
	TNT::Array1D<double> results(*nperm);
	for (int ii=0;ii<*nperm;ii++) results[ii]=log(weights[j][k][ii])+llike[j][k][ii];
	double scale=*(std::max_element(&results[0],&results[0]+*nperm));
	double sm=0.0;
	for (int i=0;i<*nperm;i++)  sm += exp(results[i]-scale);
	ll[j*(*nrho)+k]  = log(sm) - log(W) + scale;
      }
    } 
  }
  /**************************************************************************************/
  /** Now for a version that uses the path                                              */
  /**************************************************************************************/
  void sdpacpath(int *data, int *ss, int *sites, double *dis, int *pop
	      , double *rho, int *nrho
	      ,double *F, int *nF, double *drive, int *nperm,double *ll) {
    
    hapdata hd(data,*ss,*sites);
    TNT::Array1D<double> d(*sites-1,dis);
    TNT::Array1D<int> location(*ss,pop);
  
    TNT::Array1D<double> llike(*nperm);
    TNT::Array1D<double> lsamp(*nperm);
    TNT::Array3D<double> weights(*nF,*nrho,*nperm);
    
    rng r;
    // initialise order
    TNT::Array1D<int> order(*ss);
    for (int i=0;i<*ss;i++) order[i]=i;
    
    spact<hapdata> p(hd,d,location);  

    // std::cerr << order;
    TNT::Array1D<double> driveF(p.npops(),drive[0]);
    double driverrho=drive[1];    
    for (int i=0;i<*nperm;i++) {
      std::random_shuffle(&order[0],&order[0]+*ss,r);
      lsamp[i]=p.samplepath(driverrho,driveF,order,r);
      llike[i]=p.likelihoodpath(order);
      
      for (int j=0;j<*nF;j++) {
	TNT::Array1D<double> tmpF(p.npops(),F[j]);
	for (int k=0;k<*nrho;k++) {
	  double lprior=p.logpriorpath(rho[k],&tmpF[0],order);
	  weights[j][k][i] = lprior-lsamp[i]+llike[i];
	}
      }
    }
    
    for (int j=0;j<*nF;j++) {
      for (int k=0;k<*nrho;k++) {
	double scale=*(std::max_element(&weights[j][k][0],&weights[j][k][0]+(*nperm)));
	double sm=0.0;
	for (int ii=0;ii<*nperm;ii++) sm += exp(weights[j][k][ii]-scale);
	ll[j*(*nrho)+k]  = log(sm) - log(*nperm) + scale;
      }
    } 
  }
}
